
***********************************************************************
* 第二章 附录IV图A1 我国企业招聘的35岁现象(基于2022年1月至2024年4月数据)
***********************************************************************

* 利用4159万条相对及时获取的企业招聘数据，对正文图1进行重新绘制
* 与正文图1类似，利用自然语言处理技术，生成两个变量minage、maxage，记录岗位设置的年龄下限或上限数值，若不存在年龄下限或上限信息，则设置为0

cd "D:\2024-00330+数据\2024-00330+论文数据"

use 附录IV图A1-数据.dta,clear

* 是否有年龄要求
gen age_requirement = 0
replace age_requirement = 1 if minage>0  
replace age_requirement = 1 if maxage>0    

* 是否有年龄上限
gen maxage_requirement = 0
replace maxage_requirement = 1 if maxage>0

* 是否有年龄下限
gen minage_requirement = 0
replace minage_requirement = 1 if minage>0

* 获得附录IV图A1(a) 对应统计数值
sum age_requirement maxage_requirement minage_requirement  //全样本
sum age_requirement maxage_requirement minage_requirement if data_sources=="前程无忧"  
sum age_requirement maxage_requirement minage_requirement if data_sources=="猎聘网"    
sum age_requirement maxage_requirement minage_requirement if data_sources=="智联招聘"

* 获得附录IV图A1(b) 对应统计数值
keep if maxage>0
tab maxage   //全样本
tab maxage if data_sources=="前程无忧"
tab maxage if data_sources=="猎聘网"
tab maxage if data_sources=="智联招聘"

* 整理上述统计数值，保存至日志文件夹中的“第二章_代码2结果_附录IV图A1.xls”，绘图得到附录IV图A1

