
***********************************************************************
* 第四章 正文图2 图形分析：我国劳动力市场存在“年龄歧视导致的35岁失业”吗？
***********************************************************************

cd "D:\2024-00330+数据\2024-00330+论文数据"

use 实证分析数据_2015人口普查数据.dta,clear

*  说明：正文图2对表2结果进行可视化，绘制劳动者因单位原因失去工作的可能性在35岁附近的分布情况、拟合曲线及其对应95%置信区间
*  局部线性回归：使用[-45,45]窗口期样本
*     对表2第(1)列结果进行可视化
*         首先，剔除区县固定效应
areg 是否因为单位原因失业 if abs(DistanceFrom35)<=45, abs(区县代码) cluster(区县代码)
predict 是否因为单位原因失业_r,r

*         其次，绘制因单位原因失去工作的可能性在35岁附近的分布情况、拟合曲线及其对应95%置信区间
*               注意：在cmogram使用lfitci和qfitci选项时，只能使用默认的置信区间，无法自行调整。在查询命令说明后发现，lfitci和qfitci默认的是95%置信区间。
cmogram 是否因为单位原因失业_r DistanceFrom35 if abs(DistanceFrom35)<=45, scatter cut(0) lineat(0) lfitci  histopts(bin(45)) graphopts(title(`"{fontface "仿宋":表2第(1)列}"')  xlabel(-45(45)45) ylabel(-0.6(0.3)0.6)) 
graph save  "第四章_代码2结果_正文图2_1.gph"
drop 是否因为单位原因失业_r

*     对表2第(2)列结果进行可视化
*         首先，剔除区县固定效应、个体和家庭特征控制变量
areg 是否因为单位原因失业 户主 性别 民族 受教育程度 识字 流动人口 _1年前常住地为本地 _5年前常住地为本地 已婚有配偶 有农村土地承包权 家庭人数 去年有人出生 去年有人死亡 房屋面积 房屋房间数 _10层以上楼房 _2000年后建成住房 有厨房 有厕所 购买的住房 有汽车 if abs(DistanceFrom35)<=45, abs(区县代码) cluster(区县代码)
predict 是否因为单位原因失业_r,r
*         其次，绘制因单位原因失去工作的可能性在35岁附近的分布情况、拟合曲线及其对应90%置信区间
cmogram 是否因为单位原因失业_r DistanceFrom35 if abs(DistanceFrom35)<=45, scatter cut(0) lineat(0) lfitci  histopts(bin(45)) graphopts(title(`"{fontface "仿宋":表2第(2)列}"')  xlabel(-45(45)45) ylabel(-0.6(0.3)0.6)) 
graph save  "第四章_代码2结果_正文图2_2.gph"
drop 是否因为单位原因失业_r

** 局部二次项回归：使用[-58,58]窗口期样本
**    对表2第(3)列结果进行可视化
**        首先，剔除区县固定效应
areg 是否因为单位原因失业 if abs(DistanceFrom35)<=58, abs(区县代码) cluster(区县代码)
predict 是否因为单位原因失业_r,r

**        其次，绘制因单位原因失去工作的可能性在35岁附近的分布情况、拟合曲线及其对应90%置信区间
cmogram 是否因为单位原因失业_r DistanceFrom35 if abs(DistanceFrom35)<=58, scatter cut(0) lineat(0) qfitci  histopts(bin(58)) graphopts(title(`"{fontface "仿宋":表2第(3)列}"')  xlabel(-58(58)58) ylabel(-0.6(0.3)0.6))
graph save  "第四章_代码2结果_正文图2_3.gph"
drop 是否因为单位原因失业_r

*     对表2第(4)列结果进行可视化
*         首先，剔除区县固定效应、个体和家庭特征控制变量
areg 是否因为单位原因失业 户主 性别 民族 受教育程度 识字 流动人口 _1年前常住地为本地 _5年前常住地为本地 已婚有配偶 有农村土地承包权 家庭人数 去年有人出生 去年有人死亡 房屋面积 房屋房间数 _10层以上楼房 _2000年后建成住房 有厨房 有厕所 购买的住房 有汽车 if abs(DistanceFrom35)<=58, abs(区县代码) cluster(区县代码)
predict 是否因为单位原因失业_r,r

*         其次，绘制因单位原因失去工作的可能性在35岁附近的分布情况、拟合曲线及其对应90%置信区间
cmogram 是否因为单位原因失业_r DistanceFrom35 if abs(DistanceFrom35)<=58, scatter cut(0) lineat(0) qfitci  histopts(bin(58)) graphopts(title(`"{fontface "仿宋":表2第(4)列}"')  xlabel(-58(58)58) ylabel(-0.6(0.3)0.6)) 
graph save  "第四章_代码2结果_正文图2_4.gph"
drop 是否因为单位原因失业_r

*  将上图合并、手动调整图形后另存为图2图形分析.gph和图2图形分析.png
gr combine "第四章_代码2结果_正文图2_1.gph"  "第四章_代码2结果_正文图2_2.gph" "第四章_代码2结果_正文图2_3.gph" "第四章_代码2结果_正文图2_4.gph"
  
cd "D:\2024-00330+数据\2024-00330+日志文件"
graph save "Graph" 第四章_代码2结果_正文图2.gph    


