
***********************************************************************
* 第四章 附录II图II1  稳健性检验：替换窗宽
***********************************************************************

cd "D:\2024-00330+数据\2024-00330+论文数据"

use 实证分析数据_2015人口普查数据.dta,clear

*  说明：使用30—50个月的窗宽进行检验，先进行回归，汇总得到over35的估计系数和90%置信区间，再画图（使用95%置信区间画图结果一致，可自行调整）。

*  对表2第(1)列局部线性回归（不含控制变量）进行检验
forvalue b=30(1)50{
areg 是否因为单位原因失业 Over35 DistanceFrom35 Over35_DistanceFrom35 if abs(DistanceFrom35)<=`b', abs(区县代码) cluster(区县代码)
eststo
}
cd "D:\2024-00330+数据\2024-00330+日志文件"
esttab, ar2  b(%9.4f) t(%9.4f) ci level(90) star(* 0.10 ** 0.05 *** 0.01) nogap, using 第四章_代码3结果_附录II图II1_表2第1列.csv, replace
estimate drop est*

*  对表2第(2)列局部线性回归（加入控制变量）进行检验
forvalue b=30(1)50{
areg 是否因为单位原因失业 Over35 DistanceFrom35 Over35_DistanceFrom35 户主 性别 民族 受教育程度 识字 流动人口 _1年前常住地为本地 _5年前常住地为本地 已婚有配偶 有农村土地承包权 家庭人数 去年有人出生 去年有人死亡 房屋面积 房屋房间数 _10层以上楼房 _2000年后建成住房 有厨房 有厕所 购买的住房 有汽车 if abs(DistanceFrom35)<=`b', abs(区县代码) cluster(区县代码)
eststo
}
esttab, ar2  b(%9.4f) t(%9.4f) ci level(90)  star(* 0.10 ** 0.05 *** 0.01) nogap, using 第四章_代码3结果_附录II图II1_表2第2列.csv, replace
estimate drop est*

*  对表2第(3)列局部二次项回归（不含控制变量）进行检验
forvalue b=50(1)70{
areg 是否因为单位原因失业 Over35 DistanceFrom35 Over35_DistanceFrom35 DistanceFrom35_sq Over35_DistanceFrom35_sq if abs(DistanceFrom35)<=`b', abs(区县代码) cluster(区县代码)
eststo
}
esttab, ar2  b(%9.4f) t(%9.4f) ci level(90) star(* 0.10 ** 0.05 *** 0.01) nogap, using 第四章_代码3结果_附录II图II1_表2第3列.csv, replace
estimate drop est*

*  对表2第(4)列局部二次项回归（加入控制变量）进行检验
forvalue b=50(1)70{
areg 是否因为单位原因失业 Over35 DistanceFrom35 Over35_DistanceFrom35 DistanceFrom35_sq Over35_DistanceFrom35_sq 户主 性别 民族 受教育程度 识字 流动人口 _1年前常住地为本地 _5年前常住地为本地 已婚有配偶 有农村土地承包权 家庭人数 去年有人出生 去年有人死亡 房屋面积 房屋房间数 _10层以上楼房 _2000年后建成住房 有厨房 有厕所 购买的住房 有汽车 if abs(DistanceFrom35)<=`b', abs(区县代码) cluster(区县代码)
eststo
}
esttab, ar2  b(%9.4f) t(%9.4f) ci level(90) star(* 0.10 ** 0.05 *** 0.01) nogap, using 第四章_代码3结果_附录II图II1_表2第4列.csv, replace
estimate drop est*


*  汇总上述回归得到的Over35估计系数、90%置信区间，保存至附录II图II1_稳健性检验_替换窗宽_画图数据.dta文件

*  利用附录II图II1_稳健性检验_替换窗宽_画图数据.dta文件，绘制附录II图II1

cd "D:\2024-00330+数据\2024-00330+论文数据"

use 附录II图II1_稳健性检验_替换窗宽_画图数据.dta,clear

*  对表2第(1)列局部线性回归（不含控制变量）进行检验
twoway (scatter coef bandwidth if linear == 1 & control ==0)( rcap  up down bandwidth if linear == 1 & control ==0), title(`"{fontface "仿宋":表2第(1)列}"') yscale(range(-0.2 0.6)) ylabel(-0.2(0.2)0.6) yline(0) yscale(range(-0.2 0.6)) xlabel(30(1)50)
graph save  "第四章_代码3结果_附录II图II1_表2第1列.gph"

*  对表2第(2)列局部线性回归（不含控制变量）进行检验
twoway (scatter coef bandwidth if linear == 1 & control ==1)( rcap  up down bandwidth if linear == 1 & control ==1), title(`"{fontface "仿宋":表2第(2)列}"') yscale(range(-0.2 0.6)) ylabel(-0.2(0.2)0.6) yline(0) yscale(range(-0.2 0.6)) xlabel(30(1)50) 
graph save  "第四章_代码3结果_附录II图II1_表2第2列.gph"

*  对表2第(3)列局部线性回归（不含控制变量）进行检验
twoway (scatter coef bandwidth if linear == 0 & control ==0)( rcap  up down bandwidth if linear == 0 & control ==0), title(`"{fontface "仿宋":表2第(3)列}"') yscale(range(-0.2 0.6)) ylabel(-0.2(0.2)0.6) yline(0) yscale(range(-0.2 0.6)) xlabel(50(1)70) 
graph save  "第四章_代码3结果_附录II图II1_表2第3列.gph"

*  对表2第(4)列局部线性回归（不含控制变量）进行检验
twoway (scatter coef bandwidth if linear == 0 & control ==1)( rcap  up down bandwidth if linear == 0 & control ==1), title(`"{fontface "仿宋":表2第(4)列}"') yscale(range(-0.2 0.6)) ylabel(-0.2(0.2)0.6) yline(0) yscale(range(-0.2 0.6)) xlabel(50(1)70) 
graph save  "第四章_代码3结果_附录II图II1_表2第4列.gph"

*  将上图合并、手动调整格式，后另存为 附录II图II1.gph和附录II图II1.png
gr combine "第四章_代码3结果_附录II图II1_表2第1列.gph"  "第四章_代码3结果_附录II图II1_表2第2列.gph" "第四章_代码3结果_附录II图II1_表2第3列.gph" "第四章_代码3结果_附录II图II1_表2第4列.gph"

cd "D:\2024-00330+数据\2024-00330+日志文件"

graph save "Graph" 第四章_代码3结果_附录II图II1.gph    



