
***********************************************************************
* 第四章 附录II表II1  稳健性检验：替换估计方法
***********************************************************************

cd "D:\2024-00330+数据\2024-00330+论文数据"

use 实证分析数据_2015人口普查数据.dta,clear

*  首先，剔除区县固定效应

areg 是否因为单位原因失业 , abs(区县代码) cluster(区县代码)    
predict 是否因为单位原因失业_r,r

*  采用基于三角核函数的非参数方法进行稳健性检验，基于Calonico et al.（2014）方法计算最优窗宽
*  第(1)列：局部多项式的阶数为1、不含无控制变量   
rdrobust 是否因为单位原因失业_r  DistanceFrom35, c(0) p(1) kernel(tri) bwselect(mserd) vce(cluster 区县代码) 
eststo
*     说明：BW est. (h)代表窗宽，47.838，约48个月
*           Eff. Number of obs代表估计样本，109812 + 105169 = 214981

*  第(2)列：局部多项式的阶数为1、加入无控制变量     
rdrobust 是否因为单位原因失业_r  DistanceFrom35, c(0) p(1) covs(户主 性别 民族 受教育程度 识字 流动人口 _1年前常住地为本地 _5年前常住地为本地 已婚有配偶 有农村土地承包权 家庭人数 去年有人出生 去年有人死亡 房屋面积 房屋房间数 _10层以上楼房 _2000年后建成住房 有厨房 有厕所 购买的住房 有汽车) kernel(tri) bwselect(mserd) vce(cluster 区县代码) 
eststo
*     说明：BW est. (h)代表窗宽，49.123，约49个月
*           Eff. Number of obs代表估计样本，116145 + 110380 = 226525

*  第(3)列：局部多项式的阶数为2、不含无控制变量     
rdrobust 是否因为单位原因失业_r  DistanceFrom35, c(0) p(2) kernel(tri) bwselect(mserd) vce(cluster 区县代码) 
eststo
*     说明：BW est. (h)代表窗宽，97.785，约98个月
*           Eff. Number of obs代表估计样本，248550 + 233983 = 482533

*  第(4)列：局部多项式的阶数为2、加入无控制变量     
rdrobust 是否因为单位原因失业_r  DistanceFrom35, c(0) p(2) covs(户主 性别 民族 受教育程度 识字 流动人口 _1年前常住地为本地 _5年前常住地为本地 已婚有配偶 有农村土地承包权 家庭人数 去年有人出生 去年有人死亡 房屋面积 房屋房间数 _10层以上楼房 _2000年后建成住房 有厨房 有厕所 购买的住房 有汽车) kernel(tri) bwselect(mserd) vce(cluster 区县代码) 
eststo
*     说明：BW est. (h)代表窗宽，97.785，约92个月
*           Eff. Number of obs代表估计样本，248550 + 233983 = 451726

** 保存
cd "D:\2024-00330+数据\2024-00330+日志文件"

esttab, ar2 se b(%9.4f) t(%9.4f) star(* 0.10 ** 0.05 *** 0.01) nogap, using 第四章_代码4结果_附录II表II1.csv, replace
*  注意导出的并非估计使用的样本量。
