
***********************************************************************
* 第四章 附录II表II2  稳健性检验：替换固定效应
***********************************************************************

cd "D:\2024-00330+数据\2024-00330+论文数据"

use 实证分析数据_2015人口普查数据.dta,clear

*  Panel A. 将区县固定效应替换成城市固定效应
gen 城市代码=substr(地区代码,1,4)
destring 城市代码,replace
*           不含控制变量
*               局部线性回归 
areg 是否因为单位原因失业 Over35 DistanceFrom35 Over35_DistanceFrom35 if abs(DistanceFrom35)<=45, abs(城市代码) cluster(城市代码)
eststo
*               局部二次项回归
areg 是否因为单位原因失业 Over35 DistanceFrom35 Over35_DistanceFrom35 DistanceFrom35_sq Over35_DistanceFrom35_sq if abs(DistanceFrom35)<=58, abs(城市代码) cluster(城市代码)
eststo
*           加入控制变量
*               局部线性回归 
areg 是否因为单位原因失业 Over35 DistanceFrom35 Over35_DistanceFrom35 户主 性别 民族 受教育程度 识字 流动人口 _1年前常住地为本地 _5年前常住地为本地 已婚有配偶 有农村土地承包权 家庭人数 去年有人出生 去年有人死亡 房屋面积 房屋房间数 _10层以上楼房 _2000年后建成住房 有厨房 有厕所 购买的住房 有汽车 if abs(DistanceFrom35)<=45, abs(城市代码) cluster(城市代码)
eststo
*               局部二次项回归
areg 是否因为单位原因失业 Over35 DistanceFrom35 Over35_DistanceFrom35 DistanceFrom35_sq Over35_DistanceFrom35_sq 户主 性别 民族 受教育程度 识字 流动人口 _1年前常住地为本地 _5年前常住地为本地 已婚有配偶 有农村土地承包权 家庭人数 去年有人出生 去年有人死亡 房屋面积 房屋房间数 _10层以上楼房 _2000年后建成住房 有厨房 有厕所 购买的住房 有汽车 if abs(DistanceFrom35)<=58, abs(城市代码) cluster(城市代码)
eststo

* Panel B. 无地区固定效应
*           不含控制变量
*               局部线性回归 
reg 是否因为单位原因失业 Over35 DistanceFrom35 Over35_DistanceFrom35 if abs(DistanceFrom35)<=45, cluster(城市代码)
eststo
*               局部二次项回归
reg 是否因为单位原因失业 Over35 DistanceFrom35 Over35_DistanceFrom35 DistanceFrom35_sq Over35_DistanceFrom35_sq if abs(DistanceFrom35)<=58,  cluster(城市代码)
eststo
*           加入控制变量
*               局部线性回归 
reg 是否因为单位原因失业 Over35 DistanceFrom35 Over35_DistanceFrom35 户主 性别 民族 受教育程度 识字 流动人口 _1年前常住地为本地 _5年前常住地为本地 已婚有配偶 有农村土地承包权 家庭人数 去年有人出生 去年有人死亡 房屋面积 房屋房间数 _10层以上楼房 _2000年后建成住房 有厨房 有厕所 购买的住房 有汽车 if abs(DistanceFrom35)<=45,  cluster(城市代码)
eststo
*               局部二次项回归
reg 是否因为单位原因失业 Over35 DistanceFrom35 Over35_DistanceFrom35 DistanceFrom35_sq Over35_DistanceFrom35_sq 户主 性别 民族 受教育程度 识字 流动人口 _1年前常住地为本地 _5年前常住地为本地 已婚有配偶 有农村土地承包权 家庭人数 去年有人出生 去年有人死亡 房屋面积 房屋房间数 _10层以上楼房 _2000年后建成住房 有厨房 有厕所 购买的住房 有汽车 if abs(DistanceFrom35)<=58,  cluster(城市代码)
eststo

cd "D:\2024-00330+数据\2024-00330+日志文件"

esttab, ar2 se b(%9.4f) t(%9.4f) star(* 0.10 ** 0.05 *** 0.01) nogap, using 第四章_代码5结果_附录II表II2.csv, replace
estimate drop est*
