
***********************************************************************
* 第四章 附录II表II4  稳健性检验：利用劳动能力和参与意愿重新定义劳动者
***********************************************************************

cd "D:\2024-00330+数据\2024-00330+论文数据"

use 实证分析数据_2015人口普查数据.dta,clear

*  基准回归剔除以下受访者样本：回答因丧失工作能力、毕业后未工作、离退休以及料理家务而失去工作的劳动者
*  涉及变量“失业原因”
*      1、在校学习
*      2、丧失工作能力
*      3、毕业后未工作
*      4、因单位原因失去工作
*      5、因本人原因失去工作
*      6、承包土地被征用
*      7、离退休
*      8、料理家务
*      9、其他
drop if (失业原因 == "2" |失业原因 == "3" |失业原因 == "7" |失业原因 == "8" )
      
*  稳健性检验
areg 是否因为单位原因失业 Over35 DistanceFrom35 Over35_DistanceFrom35 if abs(DistanceFrom35)<=45, abs(区县代码) cluster(区县代码)
eststo

areg 是否因为单位原因失业 Over35 DistanceFrom35 Over35_DistanceFrom35 户主 性别 民族 受教育程度 识字 流动人口 _1年前常住地为本地 _5年前常住地为本地 已婚有配偶 有农村土地承包权 家庭人数 去年有人出生 去年有人死亡 房屋面积 房屋房间数 _10层以上楼房 _2000年后建成住房 有厨房 有厕所 购买的住房 有汽车 if abs(DistanceFrom35)<=45, abs(区县代码) cluster(区县代码)
eststo

areg 是否因为单位原因失业 Over35 DistanceFrom35 Over35_DistanceFrom35 DistanceFrom35_sq Over35_DistanceFrom35_sq if abs(DistanceFrom35)<=58, abs(区县代码) cluster(区县代码)
eststo

areg 是否因为单位原因失业 Over35 DistanceFrom35 Over35_DistanceFrom35 DistanceFrom35_sq Over35_DistanceFrom35_sq 户主 性别 民族 受教育程度 识字 流动人口 _1年前常住地为本地 _5年前常住地为本地 已婚有配偶 有农村土地承包权 家庭人数 去年有人出生 去年有人死亡 房屋面积 房屋房间数 _10层以上楼房 _2000年后建成住房 有厨房 有厕所 购买的住房 有汽车 if abs(DistanceFrom35)<=58, abs(区县代码) cluster(区县代码)
eststo

cd "D:\2024-00330+数据\2024-00330+日志文件"

esttab, ar2 se b(%9.4f) t(%9.4f) star(* 0.10 ** 0.05 *** 0.01) nogap, using 第四章_代码8结果_附录II表II4.csv, replace
estimate drop est*
